package org.jbpm.gd.jpdl.ui.properties;

import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.ui.IWorkbenchPart;
import org.eclipse.ui.views.properties.tabbed.AbstractPropertySection;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetPage;
import org.jbpm.gd.common.notation.AbstractNotationElement;
import org.jbpm.gd.jpdl.model.Mail;
import org.jbpm.gd.jpdl.ui.graph.part.NotationElementGraphicalEditPart;
import org.jbpm.gd.jpdl.ui.outline.part.JpdlOutlineEditPart;


public class MailSection extends AbstractPropertySection {
	
	private MailConfigurationComposite mailConfigurationComposite;
	private Mail mail;
	
	public void createControls(Composite parent,
            TabbedPropertySheetPage aTabbedPropertySheetPage) {
        super.createControls(parent, aTabbedPropertySheetPage);
        Composite clientArea = getWidgetFactory().createFlatFormComposite(parent);
        mailConfigurationComposite = MailConfigurationComposite.create(getWidgetFactory(), clientArea);
    }
 
 	public void setInput(IWorkbenchPart part, ISelection selection) {
        super.setInput(part, selection);
        if (!(selection instanceof IStructuredSelection)) return;
        Object input = ((IStructuredSelection)selection).getFirstElement();
        if (input instanceof NotationElementGraphicalEditPart) {
        	AbstractNotationElement notationElement = ((NotationElementGraphicalEditPart)input).getNotationElement();
        	input = notationElement.getSemanticElement();
        } else if (input instanceof JpdlOutlineEditPart) {
        	input = ((JpdlOutlineEditPart)input).getModel();
        }
        if (input instanceof Mail) {
        	setMail((Mail)input);
        }
    }
 	
 	private void setMail(Mail mail) {
 		this.mail = mail;
 	}

 	public void refresh() {
 		if (mail != null) {
 			mailConfigurationComposite.setMail(mail);
 		}
    }
 	
	public boolean shouldUseExtraSpace() {
		return true;
	}
	
}